#ifndef _COLORS
#define _COLORS


// strutture usate per i colori
typedef struct { GLfloat r, g, b; } t_rgb;
typedef struct { GLfloat r, g, b, a; } t_rgba;


t_rgba rainbow[7] = {
	{0,1,1, 1}, // ciano
	{0,0,1, 1}, // blu
	{1,0,1, 1}, // viola
	{1,0,0, 1}, // rosso
	{1,1,0, 1}, // giallo
	{0,1,0, 1}, // verde

	{0,1,1, 1}  // (ciano)
};


t_rgba hsv[4] = {
	{1,0,0, 1}, // rosso
	{0,1,0, 1}, // verde
	{0,0,1, 1}, // blu

	{1,0,0, 1}  // rosso
};



__inline void color_set3f(t_rgb *c, float r, float g, float b);
__inline void color_set4f(t_rgba *c, float r, float g, float b, float a);
__inline void color_interpolatete3f(t_rgb *dest, t_rgb *c1, t_rgb *c2, float val);
__inline void color_interpolatete4f(t_rgba *dest, t_rgba *c1, t_rgba *c2, float val);

void  color_get_rainbow4f(float s, t_rgba *dest);


__inline void color_set3f(t_rgb *c, float r, float g, float b)
{
 c->r = r;
 c->g = g;
 c->b = b;
}

__inline void color_set4f(t_rgba *c, float r, float g, float b, float a)
{
 c->r = r;
 c->g = g;
 c->b = b;
 c->a = a;
}


__inline void color_interpolatete3f(t_rgb *dest, t_rgb *c1, t_rgb *c2, float val)
{
float k = 1.0 - val;

 dest->r = c1->r * k  +  c2->r * val;
 dest->g = c1->g * k  +  c2->g * val;
 dest->b = c1->b * k  +  c2->b * val;
}

__inline void color_interpolatete4f(t_rgba *dest, t_rgba *c1, t_rgba *c2, float val)
{
float k = 1.0 - val;

 dest->r = c1->r * k  +  c2->r * val;
 dest->g = c1->g * k  +  c2->g * val;
 dest->b = c1->b * k  +  c2->b * val;
 dest->a = c1->a * k  +  c2->a * val;
}




void color_get_ramp4f(float s, float *dst_rgba,  t_rgba *src, int num_vals)
{
float s1;
float r, g, b, a;
float r1, g1, b1, a1;
t_rgba *c;


if(s < 0.0) s = -s;
if(s >= 1.0) s = fmod(s, 1.0);
s *= (float)num_vals;

 c = &src[(int)s];

 s  = fmod(s, 1.0);
 s1 = 1.0 - s;

 r1  = c->r;
 g1  = c->g;
 b1  = c->b;
 a1  = c->a;

  c++;
 r = c->r;
 g = c->g;
 b = c->b;
 a = c->a;

 dst_rgba[0] = r * s  +  r1 * s1;
 dst_rgba[1] = g * s  +  g1 * s1;
 dst_rgba[2] = b * s  +  b1 * s1;
 dst_rgba[3] = a * s  +  a1 * s1;    
}



t_rgba g_col={0,0,0,.02};

GLfloat *get_palette(float val)
{
//color_get_rainbow4f( val, &g_col );

g_col.r = val;
g_col.g = fabs(val*2.0-1.0);
g_col.b = 1.0-val;

g_col.a = val*.4; //fmod((val + g_minmax_offset) * g_minmax_k,1.0);
 return &g_col.r;
}


#endif
