#ifndef _MOUSE_LIB
#define _MOUSE_LIB

#include "trackball.h"

typedef struct
{
 int  dx, dy;
 int  x, y;
 int  old_x, old_y;

 int  x_anchor, y_anchor;

 bool moving;
 bool l_dragging, m_dragging, r_dragging;
 bool l_end_drag, m_end_drag, r_end_drag;

 bool l_down, l_dclick, l_up;
 bool m_down, m_dclick, m_up;
 bool r_down, r_dclick, r_up;

 bool wheel;
 int  wheel_val;

 bool ctrl_press;
 bool shift_press;
} t_mouse_struct;

t_mouse_struct g_Mouse;




float g_MyMatrix[16][4][4];
float g_arr_value[16];
int g_mouseinit=0;




void MouseRefresh(t_mouse_struct *m)
{

  m->shift_press = m->ctrl_press =
//  m->l_down = m->m_down = m->r_down =
  m->wheel = false;

//  m->l_up = m->m_up = m->r_up = true;

  m->wheel_val = 0;

//  m->moving = false;

  m->l_end_drag = m->m_end_drag = m->r_end_drag = false;

  m->dx  =  m->x  -  m->old_x;
  m->dy  =  m->y  -  m->old_y;

}





void mouseMotion(int x, int y)
{
 g_Mouse.moving = 1;



 g_Mouse.x = x;
 g_Mouse.y = y;




  if (g_Mouse.l_dragging) {
    /* drag in progress, simulate trackball */
    float spin_quat[4];

    trackball(spin_quat,
	      (2.0*g_Mouse.x_anchor - g_w) / g_w,
	      (g_h - 2.0*g_Mouse.y_anchor) / g_h,
	      (2.0*x - g_w) / g_w,
	      (g_h - 2.0*y) / g_h);

    add_quats(spin_quat, g_quat, g_quat);

    /* orientation has changed, redraw mesh */

  }

  if (g_Mouse.m_dragging) {
    /* zooming drag */
    g_oz += ((y - g_Mouse.y_anchor) / g_h) * .25;
    if (g_oz > 10) g_oz = 10;
    if (g_oz < -10) g_oz = -10;
    /* zoom has changed, redraw mesh */
   
  }


  if (g_Mouse.r_dragging) {
    /* zooming drag */
    g_ox += ((x - g_Mouse.x_anchor) / g_w) * .25;
    g_oy -= ((y - g_Mouse.y_anchor) / g_h) * .25;
/*
    if ( g_ox <  g_oz) g_ox =  g_oz;
		 else
		if ( g_ox > -g_oz) g_ox = -g_oz;

    if ( g_oy <  g_oz) g_oy =  g_oz;
		 else
		if ( g_oy > -g_oz) g_oy = -g_oz;
  */  
    /* zoom has changed, redraw mesh */
   
  }

 g_Mouse.old_x = g_Mouse.x;
 g_Mouse.old_y = g_Mouse.y;


 glutPostRedisplay();
}




void mouseFunction(int button, int state, int x, int y)
{

if(state == GLUT_UP)
{
	if(button == GLUT_LEFT_BUTTON) 
	{  
		 g_Mouse.l_up = 1;
		 if(g_Mouse.l_dragging)
		 {
			 g_Mouse.l_end_drag = 1;
		   g_Mouse.l_dragging = 0;
		 }
	   g_Mouse.l_down = 0; 
	} 

//---------------------------------------
	if(button == GLUT_MIDDLE_BUTTON) 
	{  
		 g_Mouse.m_up = 1;
		 if(g_Mouse.m_dragging)
		 {
			 g_Mouse.m_end_drag = 1;
		   g_Mouse.m_dragging = 0;
		 }
	   g_Mouse.m_down = 0;
	} 

//---------------------------------------
	if(button == GLUT_RIGHT_BUTTON) 
	{  
		 g_Mouse.r_up = 1;
		 if(g_Mouse.r_dragging)
		 {
			  g_Mouse.r_end_drag = 1;
		    g_Mouse.r_dragging = 0;
		 }
	   g_Mouse.r_down = 0;
	}  


}
//---------------------------------------



if(state == GLUT_DOWN)
{

	if(button == GLUT_LEFT_BUTTON)
	{	  
   g_Mouse.l_down = 1;
	 if( !g_Mouse.l_dragging )
		 {
		   g_Mouse.l_dragging = 1; 
			 g_Mouse.l_end_drag = 0;
       g_Mouse.l_up = 0;

			 g_Mouse.x_anchor = x;
			 g_Mouse.y_anchor = y;
		 }
	}  else g_Mouse.l_down = 0;


//---------------------------------------
	if(button == GLUT_MIDDLE_BUTTON)
	{	  
   g_Mouse.m_down = 1;
	 if( !g_Mouse.m_dragging )
		 {
		   g_Mouse.m_dragging = 1; 
			 g_Mouse.m_end_drag = 0;
       g_Mouse.m_up = 0;

			 g_Mouse.x_anchor = x;
			 g_Mouse.y_anchor = y;
		 }
	}  else g_Mouse.m_down = 0;

//---------------------------------------
	if(button == GLUT_RIGHT_BUTTON)
	{	  
   g_Mouse.r_down = 1;
	 if( !g_Mouse.r_dragging )
		 {
		   g_Mouse.r_dragging = 1; 
			 g_Mouse.r_end_drag = 0;
       g_Mouse.r_up = 0;

			 g_Mouse.x_anchor = x;
			 g_Mouse.y_anchor = y;
		 } 
	}  else g_Mouse.r_down = 0;
}


//if(!g_Mouse.moving) glutPostRedisplay();

}



#endif
